# -*- coding: utf-8 -*-

"""
/***************************************************************************
 HouseDetection
                                 A QGIS plugin
 This plugin detects houses in a shape
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                              -------------------
        begin                : 2020-07-31
        copyright            : (C) 2020 by Soluciones 3f
        email                : pablo.aguayo@soluciones3f.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""

__author__ = 'Soluciones 3f'
__date__ = '2020-07-31'
__copyright__ = '(C) 2020 by Soluciones 3f'

# This will get replaced with a git SHA1 when you do a git archive

__revision__ = '$Format:%H$'

import os
import math
import sys
import inspect
from PIL import Image

import gdal
import csv

from qgis import processing

# Qt
from qgis.PyQt.QtCore import (
    qVersion, 
    QCoreApplication, 
    QSettings, 
    Qt,
    QTranslator, 
    QVariant, 
    QUrl
)
from qgis.PyQt.QtGui import (
    QColor,
    QCursor,
    QDesktopServices,
    QFont, 
    QIcon,
    QPixmap
)
from qgis.PyQt.QtWidgets import (
    QAction,
    QButtonGroup, 
    QDialogButtonBox,
    QMessageBox,
    QSizePolicy,
    QPushButton,
    QDialog,
    QGridLayout,
)
# Qgis
from qgis.core import (
    QgsCategorizedSymbolRenderer, 
    QgsFeature,
    QgsFeatureRequest,
    QgsField,
    QgsGeometry,
    QgsPalLayerSettings,
    QgsPoint,
    QgsPointXY,
    QgsProject,
    QgsRectangle, 
    QgsRendererCategory, 
    QgsSymbol,
    QgsTextBufferSettings, 
    QgsTextFormat, 
    QgsUnitTypes,    
    QgsVectorLayer,
    QgsVectorLayerSimpleLabeling, 
    QgsWkbTypes,
    QgsApplication,
    QgsProcessingAlgorithm,
    QgsMessageLog,
    Qgis
)
from qgis.gui import (
    QgsMapTool,
    QgsMessageBar
)
from .house_detection_provider import HouseDetectionProvider
from .house_detection_dialog import HouseDetectionDialog

cmd_folder = os.path.split(inspect.getfile(inspect.currentframe()))[0]

if cmd_folder not in sys.path:
    sys.path.insert(0, cmd_folder)


class HouseDetectionPlugin(object):

    def __init__(self, iface):
        """Constructor.

        :param iface: An interface instance that will be passed to this class
            which provides the hook by which you can manipulate the QGIS
            application at run time.
        :type iface: QgsInterface
        """
        # Save reference to the QGIS interface
        self.iface = iface
        self.provider = None

        self.SETTINGS_SECTION = 'gridcreator'
        self.MSG_TRENCHES = 'trenches'

        self.RESULT_FEATURE_POINT = 0
        self.GRID_SQUARE = 1
        self.GRID_DIAMOND = 2

        self.actions = []
        self.toolbar = self.iface.addToolBar(u'HouseDetection')
        self.toolbar.setObjectName(u'HouseDetection')

        self.first_start = None

    def initProcessing(self):
        """Init Processing provider for QGIS >= 3.8."""
        self.provider = HouseDetectionProvider()
        QgsApplication.processingRegistry().addProvider(self.provider)

    def add_action(
        self,
        icon_path,
        text,
        callback,
        enabled_flag=True,
        add_to_menu=True,
        add_to_toolbar=True,
        status_tip=None,
        whats_this=None,
        parent=None
    ):
        """Add a toolbar icon to the toolbar.

        :param icon_path: Path to the icon for this action. Can be a resource
            path (e.g. ':/plugins/foo/bar.png') or a normal file system path.
        :type icon_path: str

        :param text: Text that should be shown in menu items for this action.
        :type text: str

        :param callback: Function to be called when the action is triggered.
        :type callback: function

        :param enabled_flag: A flag indicating if the action should be enabled
            by default. Defaults to True.
        :type enabled_flag: bool

        :param add_to_menu: Flag indicating whether the action should also
            be added to the menu. Defaults to True.
        :type add_to_menu: bool

        :param add_to_toolbar: Flag indicating whether the action should also
            be added to the toolbar. Defaults to True.
        :type add_to_toolbar: bool

        :param status_tip: Optional text to show in a popup when mouse pointer
            hovers over the action.
        :type status_tip: str

        :param parent: Parent widget for the new action. Defaults None.
        :type parent: QWidget

        :param whats_this: Optional text to show in the status bar when the
            mouse pointer hovers over the action.

        :returns: The action that was created. Note that the action is also
            added to self.actions list.
        :rtype: QAction
        """

        icon = QIcon(icon_path)
        action = QAction(icon, text, parent)
        action.triggered.connect(callback)
        action.setEnabled(enabled_flag)

        if status_tip is not None:
            action.setStatusTip(status_tip)

        if whats_this is not None:
            action.setWhatsThis(whats_this)

        if add_to_toolbar:
            self.toolbar.addAction(action)

        #if add_to_menu:
        #    self.iface.addPluginToVectorMenu(
        #        self.menu,
        #        action)

        self.actions.append(action)

        return action

    def initGui(self):
        self.create_action = self.add_action(
            'C:/Users/pablo/AppData/Roaming/QGIS/QGIS3/profiles/default/python/plugins/house_detection/icon.png',
            text='Generar imagenes',
            callback=self.create_features,
            parent=self.iface.mainWindow())
        self.create_action.setCheckable(True)

        self.label_action = self.add_action(
            'C:/Users/pablo/AppData/Roaming/QGIS/QGIS3/profiles/default/python/plugins/house_detection/icon2.png',
            text='Marcar casas',
            callback=self.start_labeling,
            parent=self.iface.mainWindow())
        self.label_action.setCheckable(True)

        self.first_start = True

    def unload(self):
        QgsApplication.processingRegistry().removeProvider(self.provider)

    def get_settings_value(self, key, default=''):
        if QSettings().contains(self.SETTINGS_SECTION + key):
            key = self.SETTINGS_SECTION + key
            val = QSettings().value(key)
            return val
        else:
            return default

    def set_settings_value(self, key, value):
        key = self.SETTINGS_SECTION + key
        QSettings().setValue(key, value)

    # getter/setter for dx (saved in settings)
    def dx(self, value=None):
        if value is None:
            return float(self.get_settings_value('dx', '1000'))
        else:
            self.set_settings_value('dx', value)

    # getter/setter for dy (saved in settings)
    def dy(self, value=None):
        if value is None:
            return float(self.get_settings_value('dy', '1000'))
        else:
            self.set_settings_value('dy', value)

    def trench_width(self, value=None):
        if value is None:
            return float(self.get_settings_value('trench_width', '5000'))
        else:
            self.set_settings_value('trench_width', value)

    def trench_length(self, value=None):
        if value is None:
            return float(self.get_settings_value('trench_height', '5000'))
        else:
            self.set_settings_value('trench_height', value)
    
    def grid_shape(self, value=None):
        if value is None:
            return int(self.get_settings_value('grid_shape', str(self.GRID_SQUARE)))
        else:
            self.set_settings_value('grid_shape', value)

    def inside_polygons(self, value=None):
        if value is None:
            return self.get_settings_value('inside_polygons', 'True') in ['true', 'True', True]
        else:
            self.set_settings_value('inside_polygons', value)

    def create_features(self):
        """Run method that performs all the real work"""

        # Create the dialog with elements (after translation) and keep reference
        # Only create GUI ONCE in callback, so that it will only load when the plugin is started
        if self.first_start == True:
            self.first_start = False
            self.dlg = HouseDetectionDialog()

        # show the dialog
        self.dlg.show()
        # Run the dialog event loop
        result = self.dlg.exec_()
        # See if OK was pressed
        if result:
            folder = self.dlg.lineEdit.text()
            
            active_layer = self.iface.mapCanvas().currentLayer()
            #self.dlg.progress_bar.setValue(0)

            # for size of progress bar
            #fcount = 0
            if len(active_layer.selectedFeatures()) < 1: # NO selection
                features = active_layer.getFeatures()  # iterator
                fcount = active_layer.featureCount()
            else: # selected features
                features = active_layer.selectedFeatures()  # features[]
                fcount = len(features)

            # give the memory layer the same CRS as the source layer
            crs = active_layer.crs()

            start_x = 0
            start_y = 0
            ddx = 0  # square grid default
            if self.grid_shape() == self.GRID_DIAMOND:
                ddx = 0.5 * self.dx()
            imgn = 0
            #self.dlg.progress_bar.setMaximum(fcount)
            for f in features:
                #self.dlg.progress_bar.setValue(self.dlg.progress_bar.value() + 1)
                if f.geometry().wkbType() == QgsWkbTypes.Polygon or f.geometry().wkbType() == QgsWkbTypes.MultiPolygon or \
                f.geometry().wkbType() == QgsWkbTypes.Polygon25D or f.geometry().wkbType() == QgsWkbTypes.MultiPolygon25D :
                    # polygon
                    bbox = f.geometry().boundingBox()
                    if not self.inside_polygons():
                        # grow the bbox to be sure it is big enough to be able to rotate it
                        if bbox.width() > bbox.height():
                            bbox.setYMaximum(bbox.center().y() + bbox.width() / 2)
                            bbox.setYMinimum(bbox.center().y() - bbox.width() / 2)
                        elif bbox.height() > bbox.width():
                            bbox.setXMaximum(bbox.center().x() + bbox.height() / 2)
                            bbox.setXMinimum(bbox.center().x() - bbox.height() / 2)

                    start_x = bbox.xMinimum() + float(self.dx() / 2)
                    start_y = bbox.yMinimum() + float(self.dy() / 2)
                    for row in range(0, int(math.ceil(bbox.height() / self.dy()))):
                        for column in range(0, int(math.ceil(bbox.width() / self.dx()))):
                            self.generatePicture(start_x, start_y, folder, imgn)
                            imgn += 1
                            start_x += self.dx()
                        start_x = bbox.xMinimum() + float(self.dx() / 2)
                        if row % 2 == 0:
                            start_x += ddx
                        start_y += self.dy()


    def generatePicture(self, x, y, folder, imgn):
        w = self.trench_width() / 200
        l = self.trench_length() / 200
        QgsMessageLog.logMessage('w = %s y l = %s'%(w,l), level=Qgis.Critical)
        QgsMessageLog.logMessage('x = %s y y = %s'%(x,y), level=Qgis.Critical)
        QgsMessageLog.logMessage('Extend: %f,%f,%f,%f'%(x - l, x + l, y - w, y + w), level=Qgis.Critical)
        processing.run("qgis:rasterize",
                       {"EXTENT":"%f,%f,%f,%f"% (x - l, x + l, y - w, y + w),
                        "MAP_UNITS_PER_PIXEL":1,
                        "OUTPUT":"%sresult%s.tif"%(folder, imgn)})
        im = Image.open("%sresult%s.tif"%(folder, imgn))
        out = im.convert("RGB")
        out.save("%sresult%s.jpg"%(folder, imgn), "JPEG", quality=90)

    def start_labeling(self):
        """Run method that performs all the real work"""

        # Create the dialog with elements (after translation) and keep reference
        # Only create GUI ONCE in callback, so that it will only load when the plugin is started
        if self.first_start == True:
            self.first_start = False
            self.dlg = HouseDetectionDialog()

        # show the dialog
        self.dlg.show()
        # Run the dialog event loop
        result = self.dlg.exec_()
        # See if OK was pressed
        if result:
            folder = self.dlg.lineEdit.text()
            active_layer = self.iface.mapCanvas().currentLayer()
            caps = active_layer.dataProvider().capabilities()

            fileIndex = 0
            id = 1
            while os.path.exists('%sresult%d.csv'%(folder,fileIndex)):
                tif = gdal.Open("%sresult%d.tif"%(folder,fileIndex))
                gt = tif.GetGeoTransform()

                x_min = gt[0]
                x_size = gt[1]
                y_min = gt[3]
                y_size = gt[5]
                with open('%sresult%d.csv'%(folder,fileIndex), newline='') as csvfile:
                    spamreader = csv.reader(csvfile, delimiter=',', quotechar='|')
                    for index, row in enumerate(spamreader):
                        px = int(row[0]) * x_size + x_min #x pixel
                        py = int(row[1]) * y_size + y_min #y pixel
                        QgsMessageLog.logMessage('%f point: %f,%f'%(index, px, py), level=Qgis.Critical)

                        feat = QgsFeature(active_layer.fields(), id)
                        feat.setGeometry(QgsGeometry.fromPointXY(QgsPointXY(px, py)))
                        res, outFeats = active_layer.dataProvider().addFeatures([feat])
                        id += 1
                fileIndex += 1
            active_layer.updateExtents()
